#!/usr/bin/env python 
import sys
import re
import os
import random
import fileinput
from itertools import compress

def main(argv):
		print ("Zpracovavam nasledujici soubory: " + sys.argv[1] + " " + sys.argv[2] + "\n")
		
		ratio = 0.66;
		tratio = 0.34;
		supervised = 0;

		if argv[1] != '-old':

			# otevreni a nacteni vstupniho souboru s positivnimi prispevky
			with open(sys.argv[1], "r") as psource:
				positive = [line for line in psource]

			# otevreni a nacteni vstupniho souboru s negativnimi prispevky
			with open(sys.argv[2], "r") as nsource:
				negative = [line for line in nsource]

			allposreviews = sys.argv[3];
			allnegreviews = sys.argv[4];
			print "Test set: " + str(tratio * 100) + "%"
			print "positive: " + str(int(float(tratio) * float(allposreviews)))
			print "negative: " + str(int(float(tratio) * float(allnegreviews))) + "\n"
			random_pchoice = random.sample(positive, int(float(tratio) * float(allposreviews)))
			random_nchoice = random.sample(negative, int(float(tratio) * float(allnegreviews)))
			output = random_pchoice + random_nchoice
			random.shuffle(output)
			testing = output

			for line in random_pchoice:
				positive.remove(line)

			for line in random_nchoice:
				negative.remove(line)

			print "Training set: " + str(ratio * 100) + "%"
			print "positive: " + str(int(float(ratio) * float(allposreviews)))
			print "negative: " + str(int(float(ratio) * float(allnegreviews))) + "\n"
			random_pchoice = random.sample(positive, int(float(ratio) * float(allposreviews)))
			random_nchoice = random.sample(negative, int(float(ratio) * float(allnegreviews)))
			trainpos = random_pchoice
			trainneg = random_nchoice
			trainFile = open('trainpos.dat',"w")
			trainFile.write("".join(trainpos))
			trainFile = open('trainneg.dat',"w")
			trainFile.write("".join(trainneg))
			testFile = open('test.dat',"w")
			testFile.write("".join(testing))

		else:

			# otevreni a nacteni vstupniho souboru s testovacimi prispevky
			with open(sys.argv[4], "r") as nsource:
				testing = [line for line in nsource]

			allposreviews = sys.argv[5];
			allnegreviews = sys.argv[6];
			labeled = int(sys.argv[7]);

			with open(sys.argv[8], "r") as headers:
				header = [line for line in headers]

			with open(sys.argv[9], "r") as theaders:
				theader = [line for line in theaders]

			filename = sys.argv[10];

			for i in range (1,11):

				if os.path.isfile(filename+'-10-'+ str(i) +'tst.dat'): 
					os.remove(filename+'-10-'+ str(i) +'tst.dat')
				tstFile = open(filename+'-10-'+ str(i) +'tst.dat',"a")

				# vytvoreni trenovaciho keel souboru
				if os.path.isfile(filename+'-10-'+ str(i) +'tra.dat'): 
					os.remove(filename+'-10-'+ str(i) +'tra.dat')
				traFile = open(filename+'-10-'+ str(i) +'tra.dat',"a")

				# vytvoreni transduktivniho keel souboru
				if os.path.isfile(filename+'-10-'+ str(i) +'trs.dat'): 
					os.remove(filename+'-10-'+ str(i) +'trs.dat')
				trsFile = open(filename+'-10-'+ str(i) +'trs.dat',"a")

				# otevreni a nacteni vstupniho souboru s positivnimi prispevky
				with open(sys.argv[2], "r") as psource:
					trainp = [line for line in psource]

				# otevreni a nacteni vstupniho souboru s negativnimi prispevky
				with open(sys.argv[3], "r") as psource:
					trainn = [line for line in psource]

				tstFile.write("".join(theader))
				traFile.write("".join(header))
				trsFile.write("".join(header))
					
				print "Generating files: "
				print filename+'-10-'+ str(i) +'tra.dat'
				print filename+'-10-'+ str(i) +'trs.dat'
				print filename+'-10-'+ str(i) +'tst.dat' "\n"

				print "Test set: " + str(tratio * 100) + "%"
				print "positive: " + str(int(float(tratio) * float(allposreviews)))
				print "negative: " + str(int(float(tratio) * float(allnegreviews))) + "\n"

				tstFile.write("".join(testing))

				random.shuffle(trainp)
				random.shuffle(trainn)

				if (supervised != 1):

					print "Labeled Part: "
					print "positive: " + str(int(labeled * 0.5))
					print "negative: " + str(int(labeled * 0.5)) + "\n"
					random_pchoice = random.sample(trainp, int(labeled * 0.5))
					random_nchoice = random.sample(trainn, int(labeled * 0.5))
					labeledPart = random_pchoice + random_nchoice

					for line in labeledPart:
							traFile.write("".join(line))
							trsFile.write("".join(line))

					for line in random_pchoice:
							trainp.remove(line)

					for line in random_nchoice:
							trainn.remove(line)			

					print "Unlabeled Part: "
					print "positive: " + str(int((float(ratio) * float(allposreviews)) - (labeled * 0.5)))
					print "negative: " + str(int((float(ratio) * float(allnegreviews)) - (labeled * 0.5))) + "\n"
					random_pchoice = random.sample(trainp, int((float(ratio) * float(allposreviews)) - (labeled * 0.5)))
					random_nchoice = random.sample(trainn, int((float(ratio) * float(allnegreviews)) - (labeled * 0.5)))
					training = random_pchoice + random_nchoice

					for line in training:
						trsFile.write("".join(line))
						line = line[:-2]
						line += ' unlabeled \n'
						traFile.write("".join(line))
				else:

					print "Labeled Part: " + str(ratio * 100) + "%"
					print "positive: " + str(int(float(ratio) * float(allposreviews)))
					print "negative: " + str(int(float(ratio) * float(allnegreviews))) + "\n"
					random_pchoice = random.sample(trainp, int(float(ratio) * float(allposreviews)))
					random_nchoice = random.sample(trainn, int(float(ratio) * float(allnegreviews)))
					labeledPart = random_pchoice + random_nchoice
					for line in labeledPart:
						traFile.write("".join(line))
						trsFile.write("".join(line))

				psource.close()
				nsource.close()
				theaders.close()
				headers.close()

if __name__ == "__main__":
    main(sys.argv)